'use strict';

var _serializeError;

function _load_serializeError() {
  return _serializeError = _interopRequireDefault(require('serialize-error'));
}

var _scope;

function _load_scope() {
  return _scope = require('../../api/scope');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function runAndUpdateCI(_ref) {
  var id = _ref.id,
      scopePath = _ref.scopePath,
      verbose = _ref.verbose,
      directory = _ref.directory,
      keep = _ref.keep;

  function addCIAttrsInTheModel(_ref2) {
    var error = _ref2.error,
        startTime = _ref2.startTime;

    var endTime = Date.now().toString();
    var ciProps = { startTime, endTime, error: undefined };

    if (error) {
      var serializedError = (0, (_serializeError || _load_serializeError()).default)(error);
      ciProps.error = serializedError;
      return (0, (_scope || _load_scope()).modifyCIProps)(scopePath, id, ciProps);
    }

    return (0, (_scope || _load_scope()).modifyCIProps)(scopePath, id, ciProps);
  }

  var startTime = Date.now().toString();

  try {
    // define options
    var environment = false; // the environments are installed automatically when missing
    var save = true;
    return (0, (_scope || _load_scope()).buildInScope)({
      id,
      scopePath,
      environment,
      save,
      verbose,
      directory,
      keep
    }).then(function (_ref3) {
      var component = _ref3.component,
          buildResults = _ref3.buildResults;

      return (0, (_scope || _load_scope()).testInScope)({ id, scopePath, environment, save, verbose, directory, keep }).then(function (specsResults) {
        return addCIAttrsInTheModel({ startTime }).then(function () {
          return { specsResults, buildResults, component };
        });
      }).catch(function (e) {
        return addCIAttrsInTheModel({ error: e, startTime }).then(function () {
          throw e;
        });
      });
    });
  } catch (e) {
    return addCIAttrsInTheModel({ error: e, startTime }).then(function () {
      throw e;
    });
  }
}

module.exports = runAndUpdateCI;
//# sourceMappingURL=run-and-update-ci.js.map